package com.example.kdan_data_center.datacenter

import com.example.kdan_data_center.KdanCloud
import com.example.kdan_data_center.datacenter.file.FileService
import com.example.kdan_data_center.datacenter.folder.FolderService
import com.example.kdan_data_center.datacenter.share.ShareLinkService
import com.example.kdan_data_center.datacenter.user.UserService

@Deprecated("Use com.kdanmobile.cloud.retrofit.datacenter.v3.DataCenter")
class DataCenter(private val kdanCloud: KdanCloud) {
    companion object {
        private const val HOST_DATA_CENTER_DEBUG = "https://preparing.kdanmobile.com:3020/"
        private const val HOST_DATA_CENTER_RELEASE = "https://data-center-rails.kdanmobile.com/"
        private const val HOST_DATA_CENTER_DEBUG_CDN = "https://preparing.kdanmobile.com:3020/"
        private const val HOST_DATA_CENTER_RELEASE_CDN = "https://data-center-rails.kdan.cn/"

        val HOST_DATA_CENTER = if (KdanCloud.ENV_DEV) HOST_DATA_CENTER_DEBUG else HOST_DATA_CENTER_RELEASE
        val HOST_DATA_CENTER_CDN = if (KdanCloud.ENV_DEV) HOST_DATA_CENTER_DEBUG_CDN else HOST_DATA_CENTER_RELEASE_CDN

        private var baseUrl = HOST_DATA_CENTER

        fun changeBaseUrl(baseUrl: String) {
            DataCenter.baseUrl = baseUrl
        }
    }

    val userService: UserService = buildUserService()
    val fileService: FileService = buildFileService()
    val folderService: FolderService = buildFolderService()
    val shareLinkService: ShareLinkService = buildShareLinkService()

    private fun buildUserService(): UserService =
            kdanCloud.getRetrofit(baseUrl + UserService.BASE_URL).create(UserService::class.java)

    private fun buildFileService(): FileService =
            kdanCloud.getRetrofit(baseUrl + FileService.BASE_URL).create(FileService::class.java)

    private fun buildFolderService(): FolderService =
            kdanCloud.getRetrofit(baseUrl + FolderService.BASE_URL).create(FolderService::class.java)

    private fun buildShareLinkService(): ShareLinkService =
            kdanCloud.getRetrofit(baseUrl + ShareLinkService.BASE_URL).create(ShareLinkService::class.java)
}